#ifndef __HELLOWORLD_CONTROL_H_
#define __HELLOWORLD_CONTROL_H_

#define SCRIPT
#define EVENT

#if defined(XPP_ACTIVEX)

#define HELLOWORLD_CONTROL_ANCESTOR CAxHelloWorldControl

//#include "ActiveX/oleconv.h" // add your custom type conversions here
#include "ActiveX/CAxHelloWorldControl.h"
#include "ActiveX/CAxHelloWorldControlPpg.h"
#include "ActiveX/HelloWorldControl_resource.h"


#elif defined(XPP_MOZILLA)

#define HELLOWORLD_CONTROL_ANCESTOR nsIHelloWorldControlX

#include "Mozilla/xpcom.h"
#include "Mozilla/nsIHelloWorldControl.h"
#include "Mozilla/nsIHelloWorldControlX.h"

#else
#error XPP control interface not defined, use /d:controlinterface=XPCom or /d:controlinterface=OleControl
#endif


class HelloWorldControl : public HELLOWORLD_CONTROL_ANCESTOR {
friend LRESULT CALLBACK HelloWorldControl_wndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
public:
	HelloWorldControl();
	virtual ~HelloWorldControl();

  SCRIPT void MsgBox(IN int a);
  SCRIPT EVENT void AfterHelloEvent();


  virtual HWND GetHwnd() { return hWnd; }

#ifdef XPP_ACTIVEX
	virtual HRESULT OnActivateInPlace(BOOL bUIActivate, LPMSG pMsg);
#endif
#ifdef XPP_MOZILLA
  virtual void SetHwnd(HWND hwnd);
#endif

private:
  void createWindow();
  LRESULT wndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
  HWND hWnd;

};

#endif //__HELLOWORLD_CONTROL_H_